'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _screen = require('./output/screen');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Topic = function () {
  function Topic(commands, out) {
    (0, _classCallCheck3.default)(this, Topic);

    this.out = out;
    this.commands = commands;
  }

  (0, _createClass3.default)(Topic, [{
    key: 'help',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(args, matchedCommand) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (matchedCommand) this.commandHelp(matchedCommand);
                if (this.constructor.topic === args[0]) this.listCommandsHelp();

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function help(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return help;
    }()
  }, {
    key: 'listCommandsHelp',
    value: function listCommandsHelp() {
      var _this = this;

      var commands = this.commands.filter(function (c) {
        return !c.hidden;
      }).map(function (c) {
        return [_this.usage(c), c.description];
      });
      if (commands.length === 0) return;
      this.out.log(this.out.config.bin + ' ' + this.constructor.topic + ' commands: (' + this.out.color.cmd(this.out.config.bin + ' help ' + this.constructor.topic + ':COMMAND') + ' for details)\n');
      this.out.log(this.renderList(commands));
      this.out.log();
    }
  }, {
    key: 'commandHelp',
    value: function commandHelp(command) {
      var usage = this.out.config.bin + ' ' + this.usage(command);
      this.out.log('Usage: ' + this.out.color.cmd(usage) + '\n');
      if (command.description) this.out.log(command.description.trim() + '\n');
      var flags = (command.flags || []).filter(function (f) {
        return !f.hidden;
      });
      if (flags.length) this.out.log(this.renderFlags(flags) + '\n');
      if (command.help) this.out.log(command.help.trim() + '\n');
    }
  }, {
    key: 'renderArg',
    value: function renderArg(arg) {
      var name = arg.name.toUpperCase();
      if (arg.required !== false && arg.optional !== true) return '' + name;else return '[' + name + ']';
    }
  }, {
    key: 'renderFlags',
    value: function renderFlags(flags) {
      flags.sort(function (a, b) {
        if (a.char && !b.char) return -1;
        if (b.char && !a.char) return 1;
        if (a.name < b.name) return -1;
        if (b.name < a.name) return 1;
        return 0;
      });
      return this.renderList(flags.map(function (f) {
        var label = [];
        if (f.char) label.push('-' + f.char);
        if (f.name) label.push(' --' + f.name);
        var usage = f.hasValue ? ' ' + f.name.toUpperCase() : '';
        var description = f.description || '';
        if (f.required || f.optional === false) description = '(required) ' + description;
        return [label.join(',').trim() + usage, description];
      }));
    }
  }, {
    key: 'usage',
    value: function usage(command) {
      if (command.usage) return command.usage.trim();
      var cmd = command.command ? command.topic + ':' + command.command : command.topic;
      if (!command.args) return cmd.trim();
      var args = command.args.map(this.renderArg);
      return (cmd + ' ' + args.join(' ')).trim();
    }
  }, {
    key: 'renderList',
    value: function renderList(items) {
      var _this2 = this;

      var S = require('string');
      var max = require('lodash.maxby');

      var maxLength = max(items, '[0].length')[0].length + 1;
      var lines = items.map(function (i) {
        var left = ' ' + i[0];
        var right = i[1];
        if (!right) return left;
        left = '' + S(left).padRight(maxLength);
        right = _this2.linewrap(maxLength + 4, right);
        return left + ' # ' + right;
      });
      return lines.join('\n');
    }
  }, {
    key: 'linewrap',
    value: function linewrap(length, s) {
      var linewrap = require('./output/linewrap');
      return linewrap(length, _screen.stdtermwidth, {
        skipScheme: 'ansi-color'
      })(s).trim();
    }
  }]);
  return Topic;
}();
/* globals
   Class
 */

Topic.hidden = false;


module.exports = Topic;